<?php

/**
 * cumplido_total actions.
 *
 * @package    controlComisiones
 * @subpackage cumplido_total
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cumplido_totalActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_CUMPLIDO_V', 'COM_PAGO_EGRESO', 'COM_CUENTA_V', 'COM_RESOLUCION', 'COM_COMISION', 'PROYECTOS', 'COM_TERCERO', 'TIPOS_COMISION'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso' => 'COM_CUMPLIDO_V'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'COM_PAGO_EGRESO'
        )
        , 'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'COM_CUENTA_V'
        ),
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
             'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_CUENTA_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_CUMPLIDO_V' =>
        array(
            'id_cumplido' => 'id_cumplido',
            'id_pago_egreso' => 'id_pago_egreso',
            'id_anhos' => 'id_anhos',
            'fecha_cumplido' => 'fecha_cumplido',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_fin' => 'fecha_fin',
            'dias_cumplido' => 'dias_cumplido',
            'observaciones' => 'observaciones',
            'id_mae_ter' => 'id_mae_ter',
            'num_doc_jefe' => 'num_doc_jefe',
            'razon_soc_jefe' => 'razon_soc_jefe'
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'id_cuenta' => 'id_cuenta',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'valor_neto' => 'valor_neto',
        ),
        'COM_CUENTA_V' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'valor' => 'valor'
        ),
        'COM_RESOLUCION' =>
        array(
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos_resol',
            'estado' => 'estado_resol'
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio_comi',
            'fecha_fin' => 'fecha_fin_comi',
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_CUMPLIDO_V' =>
        array(
            'id_cumplido,a' => array('!=' => array(-1)),
            'id_cumplido,b' => array('=' => array('id_cumplido')),
            'id_pago_egreso' => array('=' => array('id_pago_egreso')),
            'id_anhos' => array('=' => array('id_anhos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_CUENTA_V' =>
        array(
            'id_tercero' => array('=' => array('id_tercero')),
        ),
        'COM_PAGO_EGRESO' =>
        array(
            'no_pago' => array('=' => array('no_pago')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_cumplido'; //identificador de la tabla
    protected $id_names = array('id_cumplido'); //llave primaria
    protected $field_names = array('id_pago_egreso', 'id_anhos', 'fecha_cumplido', 'fecha_inicio', 'fecha_fin', 'dias_cumplido', 'observaciones', 'id_mae_ter'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_CUMPLIDO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_cumplido'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                $id_pago_egreso = $list_data_post[0]['id_pago_egreso'];
                $id_anhos = $list_data_post[0]['id_anhos'];
                $id_cumplido = $list_data_post[0]['id_cumplido'];
                $dias_cumplido = $list_data_post[0]['dias_cumplido'];
                $fecha_gasto = $list_data_post[0]['fecha_cumplido'];

                $sql = <<<EOD
select tab8.tarifa,tab7.id_mae_ter,tab3.num_doc,tab6.id_elementos_gasto

from com_pago_egreso tab0
left join com_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta
left join com_resolucion tab2 ON tab2.id_resolucion = tab1.id_resolucion
left join com_tercero tab3 ON tab3.id_tercero = tab1.id_tercero
left join com_comisionado_obj tab4 ON tab4.id_comision = tab2.id_comision and tab4.id_tercero = tab3.id_tercero
join objetos_gasto tab5 ON tab5.id = tab4.id_obj_gasto and tab5.viatico = 1
join pr_elementos_gasto tab6 ON tab6.id_objeto_gasto = tab5.id and tab6.viatico =  1
left join interceros tab7 ON to_char(tab7.num_doc) = to_char(tab3.num_doc)                        
left join com_comisionado tab8 ON tab4.id_comision = tab2.id_comision and tab8.id_tercero = tab3.id_tercero


where tab0.id_pago_egreso = $id_pago_egreso
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $tarifa = $records[0]['tarifa'];
                $id_mae_ter = $records[0]['id_mae_ter'];
                $no_documento = $records[0]['num_doc'];
                $id_elementos_gasto = $records[0]['id_elementos_gasto'];

                $valor = $dias_cumplido * $tarifa;
                $valor = round($valor);
                $observaciones = "GASTO CORRESPONDIENTE A VIATICOS";




                $sql = <<<EOD
            INSERT INTO COM_REGISTRO_GASTO (ID_PAGO_EGRESO,ID_ANHOS,ID_ELEMENTOS_GASTO,ID_MAE_TER,NO_DOCUMENTO,FECHA_GASTO,VR_BRUTO,VR_IVA,VR_RETENCION,
                        VR_NETO,OBSERVACIONES)
               VALUES($id_pago_egreso,$id_anhos,$id_elementos_gasto,$id_mae_ter,$no_documento,to_date('$fecha_gasto','YYYY-MM-DD'),$valor,0,0,$valor
                   ,'$observaciones')
EOD;
                //20170614  se omite la creacion de registros de gastos cuando se realiza el cumplido de l acomision
                //ticket 6489
                //$this->conn->execute($sql);
                
                
                // LEGALIZAR GASTOS DE VIAJE
                
                $sql = <<<EOD
select tab0.id_pago_egreso,tab7.id_mae_ter,tab3.num_doc,tab6.id_elementos_gasto,tab8.valor

from com_pago_egreso tab0
left join com_cuenta tab1 ON tab1.id_cuenta = tab0.id_cuenta
left join com_resolucion tab2 ON tab2.id_resolucion = tab1.id_resolucion
left join com_tercero tab3 ON tab3.id_tercero = tab1.id_tercero
left join com_comisionado_obj tab4 ON tab4.id_comision = tab2.id_comision and tab4.id_tercero = tab3.id_tercero
join objetos_gasto tab5 ON tab5.id = tab4.id_obj_gasto and tab5.viaje = 1
join pr_elementos_gasto tab6 ON tab6.id_objeto_gasto = tab5.id and tab6.viaje =  1
left join interceros tab7 ON to_char(tab7.num_doc) = to_char(tab3.num_doc)                        
left join com_comisionado_obj tab8 ON tab8.id_comision = tab2.id_comision and tab8.id_tercero = tab3.id_tercero and tab8.ID_OBJ_GASTO = tab5.id
                        
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_mae_ter = $records[0]['id_mae_ter'];
                $no_documento = $records[0]['num_doc'];
                $id_elementos_gasto = $records[0]['id_elementos_gasto'];

                $valor = $records[0]['valor'];
                $valor = round($valor);
                $observaciones = "LEGALIZACION GASTOS DE VIAJE";




                $sql = <<<EOD
            INSERT INTO COM_REGISTRO_GASTO (ID_PAGO_EGRESO,ID_ANHOS,ID_ELEMENTOS_GASTO,ID_MAE_TER,NO_DOCUMENTO,FECHA_GASTO,VR_BRUTO,VR_IVA,VR_RETENCION,
                        VR_NETO,OBSERVACIONES)
               VALUES($id_pago_egreso,$id_anhos,$id_elementos_gasto,$id_mae_ter,$no_documento,to_date('$fecha_gasto','YYYY-MM-DD'),$valor,0,0,$valor
                   ,'$observaciones')
EOD;

                //20170614  se omite la creacion de registros de gastos cuando se realiza el cumplido de l acomision
                //ticket 6489
                //$this->conn->execute($sql);


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_pago_egreso = $request['id_pago_egreso'];
        
        
        
        $sql = <<<EOD
SELECT count(tab0.id_cumplido) cantidad

from com_cumplido tab0
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];
        
        if($cantidad>0){
            
            $errors['mensaje'] = "Ya se ha registrado cumplido para esta comision. Favor verificar";
            $errors['servicio'] = "cumplido";
            
        }

        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_cumplido = $request['id_cumplido'];
        
        $sql = <<<EOD
select id_pago_egreso from com_cumplido where id_cumplido = $id_cumplido
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $id_pago_egreso = $records[0]['id_pago_egreso'];
        
        
        $sql = <<<EOD
SELECT count(tab0.id_registro_gasto) cantidad

from com_registro_gasto tab0
join pr_elementos_gasto tab1 ON tab1.id_elementos_gasto = tab0.id_elementos_gasto
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];
        
        if($cantidad>0){
            
            $errors['mensaje'] = "Ya se han registrado gastos para esta comision, no se puede eliminar.";
            $errors['servicio'] = "cumplido";
            
        }
        
        
        $sql = <<<EOD
SELECT count(tab0.id_radicado) cantidad

from com_radicado tab0
where tab0.id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];
        
        if($cantidad>0){
            
            $errors['mensaje'] = "Ya se ha registrado radicado para esta comision, no se puede eliminar.";
            $errors['servicio'] = "cumplido";
            
        }
        
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }
}
